----------------------------------------------------------------------------
--------------------"The simplest design is always the best design." -------
---@v1.1.0.3----------------------------------------------------------------
----------------------------------------------------------------------------
-- Copyright (C)ViperGTS96, Confidential, All Rights Reserved.--------------
----------------------------------------------------------------------------

source(Utils.getFilename("waterBodyFX.lua", g_currentModDirectory));

waterBodyFXReg = {};
waterBodyFXReg.modDirectory = g_currentModDirectory;

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
waterBodyFXReg.version = getXMLString(modDesc, "modDesc.version");

function installSpec()
	if g_specializationManager:getSpecializationByName("waterBodyFX") == nil then
		if waterBodyFX == nil then 
			print("ERROR: unable to find source file 'waterBodyFX'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					local isAnimated = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						elseif name == "animatedVehicle" then 
							isAnimated = true;
						end;
					end;
					if isWashable and isAnimated then
						typeDef.specializationsByName["waterBodyFX"] = waterBodyFX;
						table.insert(typeDef.specializationNames, "waterBodyFX");
						table.insert(typeDef.specializations, waterBodyFX);
					end;
				end;
			end;
		end;	
	end;
end;

function waterBodyFXReg:incompatible()
	local incompatible = g_modIsLoaded["FS19_RM_Seasons"];
	return incompatible;
end;

if not waterBodyFXReg:incompatible() then
	VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, installSpec);
else
	waterBodyFX:disable()
end;
waterBodyFX:setDir(waterBodyFXReg.modDirectory);

function waterBodyFXReg:loadMap()
	g_currentMission.waterBodyFX = {waterY = g_currentMission.waterY};
	g_currentMission.waterY = g_currentMission.waterY - 1000;
end;

addModEventListener(waterBodyFXReg);